/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! COPYRIGHT    (c)  2005 CAHA, Spain
! IDENT        imarith.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      C version of dist_cor.pl
! COMMENT      No GROUP information included. No header data properly copied
! VERSION      0.1  08.08.05 : Creation, SF.
------------------------------------------------------------------------------*/

#include <IFU_io.h>

#include "stats.h"
#include <stdlib.h>


#include <stdio.h> //For Standard I/O
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <data_io.h> //For Lyon I/O data

#include <cpgplot.h> // PGPLOT
#include "my_math.h"


main(int argc, char *ARGV[])
{

    FILE *FH;
    IMAGE2D image,dist;

    char infile[80],dist_file[80],dist_cor_file[80];
    
    int smooth,nsearch,n_fib,plot;
    float nsigma,center_index,max_delta;
    long npix[2];
    double start[2];
    double step[2];
    float back_top;
    int nm,nm_start,min,max;
    int w_guess,delta_n,W_guess;
    int jmin,jmax,i,j,Jmin,Jmax;
    float *spec,*wave,*Spec,*Wave,*in_spec,*in_wave,*shift_wave;
    float max_peak;
    int *i_peak;
    int peak;
    int na,nb,nc;
    float a,b,c,fa,fb,fc,den;
    float *w_peak;
    float *x,*y;
    char command='1';
    float fmin,fmax;
    int k;
    float shift_min,shift_max;
    float *index,*new_index;
    float *shift,*new_shift,*tmp;
    int ks,nbox,border;
    float me,sig;
    float *out_array;

    if (argc<9) {
	printf("USE: dist_cor.pl EXTRACTED.fits CORRECTED.fits DISTORSION_CORRECTION.txt SMOOTH[0/1] start_index delta_index nsearch plot [n_fib] [nsigma] [center_index]\n");
	return(0);
    }
    set_user_dataformat();
    strcpy(infile,ARGV[1]);
    strcpy(dist_file,ARGV[2]);
    strcpy(dist_cor_file,ARGV[3]);
    smooth=atoi(ARGV[4]);
    w_guess=atoi(ARGV[5]);
    delta_n=atoi(ARGV[6]);    
    nsearch=atoi(ARGV[7]);
    plot=atoi(ARGV[8]);
    n_fib=0;
    nsigma=0.0;
    center_index=0.0;
    max_delta=1e12;
    if (argc==10) {
   	n_fib=atoi(ARGV[9]);
    }
    if (argc==11) {
	n_fib=atoi(ARGV[9]);
	nsigma=atof(ARGV[10]);
    }
    if (argc==12) {
	n_fib=atoi(ARGV[9]);
	nsigma=atof(ARGV[10]);
	center_index=atof(ARGV[11]);
    }
    if (argc==13) {
	n_fib=atoi(ARGV[9]);
	nsigma=atof(ARGV[10]);
	center_index=atof(ARGV[11]);
	max_delta=atof(ARGV[12]);
    }
//    printf("CENTER_INDEX=%f",center_index);
    printf("nsigma=%f\n",nsigma);
    open_frame(&image,infile,"I");
    npix[0]=image.nx;
    npix[1]=image.ny;
    start[0]=0.0;
    start[1]=0.0;
    step[0]=1.0;
    step[1]=1.0;
    printf("We start to compute the median...\n");
    back_top=0;
    nm=0;
    nm_start=0;
    fmin=1e12;
    fmax=-1e12;
    jmin=w_guess-delta_n;
    jmax=w_guess+delta_n;
    out_array = (float *)malloc((image.nx*image.ny)*sizeof(float));  	
    spec = (float *)malloc((image.nx)*sizeof(float));  	
    Spec = (float *)malloc((image.nx)*sizeof(float));  	
    in_spec = (float *)malloc((image.nx)*sizeof(float));  	
    wave = (float *)malloc((image.nx)*sizeof(float));  	
    Wave = (float *)malloc((image.nx)*sizeof(float));  	
    in_wave = (float *)malloc((image.nx)*sizeof(float));  	
    shift_wave = (float *)malloc((image.nx)*sizeof(float));  	
    i_peak = (int *)malloc((image.ny)*sizeof(int));  	
    w_peak = (float *)malloc((image.ny)*sizeof(float));  	
    for (nm=0;nm<image.nx;nm++) {    	
	spec[nm]=RD_frame(&image,nm,n_fib);
	wave[nm]=1.0*nm;
	if ((nm>=jmin)&&(nm<=jmax)) {
	    if (fmax<spec[nm]) {
		fmax=spec[nm];
	    }
	    if (fmin>spec[nm]) {
		fmin=spec[nm];
	    }
	}
    }
    printf("We start look for the peak ...\n");
    j=jmin;
    peak=0;
    max_peak=-1e12;
    i_peak[n_fib]=w_guess;
    while (j<jmax) {
	if (nsearch!=0) {
	    peak=1;
	    for (i=0;i<nsearch;i++) {
		if (spec[j-i]<spec[j-i-1]) {
		    peak=0;
		}
		if (spec[j+i]<spec[j+i+1]) {
		    peak=0;
		}
	    } 
	    if ((peak==1)&&(max_peak<spec[j])) {
		i_peak[n_fib]=j;    
		max_peak=spec[j];
	    }	
	} else {
	    if (max_peak<spec[j]) {
		i_peak[n_fib]=j;    
		max_peak=spec[j];
	    }
	}
	j++;
    }

    na=i_peak[n_fib]-1;
    nb=i_peak[n_fib];
    nc=i_peak[n_fib]+1;
    a=wave[na];
    b=wave[nb];
    c=wave[nc];
    fa=-spec[na];
    fb=-spec[nb];
    fc=-spec[nc];
    den=(fc-2*fb+fa);
    if (den!=0) {
	w_peak[n_fib]=c-(b-a)*((fc-fb)/den+0.5);
    } else {
	w_peak[n_fib]=w_guess;
    }

    if (center_index==0.0) {
	center_index=w_peak[n_fib];
    }
//    printf("CENTER_INDEX=%f",center_index);

    if (plot==1) {
	cpgopen("/xs");
	cpgsfs(1.2);
	cpgscf(2);
	cpgslw(2); 
	cpgsch(1.6); 
	cpgenv(jmin,jmax,fmin-5,fmax+5,0,0);
	cpgsch(1.6); 
	cpglab("X-axis","Counts","Spectral Section");
	cpgsch(2.2); 
	cpgsci(1);
	cpgline(image.nx,wave,spec);    
	cpgsci(7);
	x = (float *)malloc((1)*sizeof(float));  	
	y = (float *)malloc((1)*sizeof(float));  	
	x[0]=1.0*i_peak[n_fib];
	y[0]=spec[(int)x[0]];
	cpgpt(1,x,y,1);
	cpgsci(4);
	x[0]=w_peak[n_fib];
	y[0]=spec[(int)x[0]];
	cpgpt(1,x,y,2);
	cpgsci(1);
	free(x);
	free(y);
	cpgclos();
	cpgend;
	if (command!='A') {
	    printf("Press Enter (A for automatic, 0 for no plot, N for next plot):\n"); 
	    command=getc(stdin);
	}
	if (command=='0') {
	    plot=0;
	}
	if (command=='Q') {
	    plot=0;
	}
	if (command=='N') {
	    plot=0;
	}
	printf("command='%c'\n");
    }
    if (command=='N') {
	plot=1;
    }
    for (i=0;i<image.nx;i++) {
	Spec[i]=spec[i];
    }
    W_guess=w_guess;




    printf("We look for the peaks in all the spectra\n");
    Jmin=jmin;
    Jmax=jmax;
    fmin=1e12;
    fmax=-1e12;
    for (k=(n_fib+1);k<image.ny;k++) {
	w_guess=w_peak[k-1];
	jmin=W_guess-delta_n;
	jmax=W_guess+delta_n;

	for (nm=0;nm<image.nx;nm++) {    
	    spec[nm]=RD_frame(&image,nm,k);
	    wave[nm]=1.0*nm;
	    if ((nm>=jmin)&&(nm<=jmax)) {
		if (fmax<spec[nm]) {
		    fmax=spec[nm];
		}
		if (fmin>spec[nm]) {
		    fmin=spec[nm];
		}
	    }
	}

	peak=0;
	max_peak=-1e12;
	j=jmin;
	i_peak[k]=w_guess;
	while (j<jmax) {
	    if (nsearch!=0) {
		peak=1;
		for (i=0;i<nsearch;i++) {
		    if (spec[j-i]<spec[j-i-1]) {
			peak=0;
		    }
		    if (spec[j+i]<spec[j+i+1]) {
			peak=0;
		    }
		} 
		if ((peak==1)&&(max_peak<spec[j])) {
		    i_peak[k]=j;    
		    max_peak=spec[j];
		}
	    } else {
		if (max_peak<spec[j]) {
		    i_peak[k]=j;    
		    max_peak=spec[j];
		}
	    }
	    j++;	
	}
	
	na=i_peak[k]-1;
	nb=i_peak[k];
	nc=i_peak[k]+1;
	a=wave[na];
	b=wave[nb];
	c=wave[nc];
	fa=-spec[na];
	fb=-spec[nb];
	fc=-spec[nc];
	den=(fc-2*fb+fa);
	if (den!=0) {
	    w_peak[k]=c-(b-a)*((fc-fb)/den+0.5);
	} else {
	    w_peak[k]=w_guess;
	}


	if ((plot==1)||(plot==2)) {
	    cpgopen("/xs");
	    cpgsfs(1.2);
	    cpgscf(2);
	    cpgslw(2); 
	    cpgsch(1.6); 
	    cpgenv(jmin,jmax,fmin-5,fmax+5,0,0);
	    cpgsch(1.6); 
	    cpglab("X-axis","Counts","Spectral Section");
	    cpgsch(2.2); 
	    cpgsci(2);
	    cpgline(image.nx,wave,Spec);    
	    cpgsci(1);
	    cpgline(image.nx,wave,spec);    
	    cpgsci(7);
	    x = (float *)malloc((1)*sizeof(float));  	
	    y = (float *)malloc((1)*sizeof(float));  	
	    x[0]=1.0*i_peak[k];
	    y[0]=spec[(int)x[0]];
	    cpgpt(1,x,y,1);
	    cpgsci(4);
	    x[0]=w_peak[k];
	    y[0]=spec[(int)x[0]];
	    cpgpt(1,x,y,2);
	    cpgsci(1);
	    free(x);
	    free(y);
	    cpgclos();
	    cpgend;
	    if (command!='A') {
		printf("Press Enter (A for automatic, 0 for no plot, N for next plot):\n"); 
		command=getc(stdin);
	    }
	    if (command=='0') {
		plot=0;
	    }
	    if (command=='Q') {
		plot=0;
	    }
	    if (command=='N') {
		plot=0;
	    }

	}
    }
    if (command=='N') {
	plot=1;
    }


    Jmin=jmin;
    Jmax=jmax;
    fmin=1e12;
    fmax=-1e12;
    //    for (k=(n_fib-1);k>-1;k--) {
    for (k=n_fib;k>-1;k--) {
	w_guess=w_peak[k-1];
	jmin=W_guess-delta_n;
	jmax=W_guess+delta_n;

	for (nm=0;nm<image.nx;nm++) {    
	    spec[nm]=RD_frame(&image,nm,k);
	    wave[nm]=1.0*nm;
	    if ((nm>=jmin)&&(nm<=jmax)) {
		if (fmax<spec[nm]) {
		    fmax=spec[nm];
		}
		if (fmin>spec[nm]) {
		    fmin=spec[nm];
		}
	    }
	}

	peak=0;
	max_peak=-1e12;
	j=jmin;
	i_peak[k]=w_guess;
	while (j<jmax) {
	    if (nsearch!=0) {
		peak=1;
		for (i=0;i<nsearch;i++) {
		    if (spec[j-i]<spec[j-i-1]) {
			peak=0;
		    }
		    if (spec[j+i]<spec[j+i+1]) {
			peak=0;
		    }
		} 
		if ((peak==1)&&(max_peak<spec[j])) {
		    i_peak[k]=j;    
		    max_peak=spec[j];
		}
	    } else {
		if (max_peak<spec[j]) {
		    i_peak[k]=j;    
		    max_peak=spec[j];
		}
	    }
	    j++;	
	}
	
	na=i_peak[k]-1;
	nb=i_peak[k];
	nc=i_peak[k]+1;
	a=wave[na];
	b=wave[nb];
	c=wave[nc];
	fa=-spec[na];
	fb=-spec[nb];
	fc=-spec[nc];
	den=(fc-2*fb+fa);
	if (den!=0) {
	    w_peak[k]=c-(b-a)*((fc-fb)/den+0.5);
	} else {
	    w_peak[k]=w_guess;
	}

	if ((plot==1)||(plot==3)) {
	    cpgopen("/xs");
	    cpgsfs(1.2);
	    cpgscf(2);
	    cpgslw(2); 
	    cpgsch(1.6); 
	    cpgenv(jmin,jmax,fmin-5,fmax+5,0,0);
	    cpgsch(1.6); 
	    cpglab("X-axis","Counts","Spectral Section");
	    cpgsch(2.2); 
	    cpgsci(2);
	    cpgline(image.nx,wave,Spec);    
	    cpgsci(1);
	    cpgline(image.nx,wave,spec);    
	    cpgsci(7);
	    x = (float *)malloc((1)*sizeof(float));  	
	    y = (float *)malloc((1)*sizeof(float));  	
	    x[0]=1.0*i_peak[k];
	    y[0]=spec[(int)x[0]];
	    cpgpt(1,x,y,1);
	    cpgsci(4);
	    x[0]=w_peak[k];
	    y[0]=spec[(int)x[0]];
	    cpgpt(1,x,y,2);
	    cpgsci(1);
	    free(x);
	    free(y);
	    cpgclos();
	    cpgend;
	    if (command!='A') {
		printf("Press Enter (A for automatic, 0 for no plot, N for next plot):\n"); 
		command=getc(stdin);
	    }
	    if (command=='0') {
		plot=0;
	    }
	    if (command=='Q') {
		plot=0;
	    }
	    if (command=='N') {
		plot=0;
	    }

	}
    }
    if (command=='N') {
	plot=1;
    }

    fmin=1e12;
    fmax=-1e12;

    shift_min=1e12;
    shift_max=-1e12;

    index = (float *)malloc((image.ny)*sizeof(float));  	
    new_index = (float *)malloc((image.ny)*sizeof(float));  	
    shift = (float *)malloc((image.ny)*sizeof(float));  	
    new_shift = (float *)malloc((image.ny)*sizeof(float));  	
    tmp = (float *)malloc((image.ny)*sizeof(float));  	

    for (j=0;j<image.ny;j++) {
      index[j]=1.0*j;
      //      if (j!=n_fib) {
	shift[j]=w_peak[j]-center_index;
	//      } else {
	//shift[j]=0.0;
	//}
	if (shift_max<shift[j]) {
	    shift_max=shift[j];
	}
	if (shift_min>shift[j]) {
	    shift_min=shift[j];
	}
	new_index[j]=index[j];
	new_shift[j]=shift[j];
    }




    ks=0;
    nbox=(int)(image.ny/100);
    if (nsigma>0) {
	for (j=0;j<image.ny;j++) {
	    k=0;
	    border=0;
	    if (j<nbox) {
		jmin=j;
		jmax=j+2*nbox;
		border=1;
	    } else {
	    if (j>=(image.ny-nbox)) {
		jmin=j-2*nbox;
		jmax=j;
		border=1;
	    } else {
		jmin=j-nbox;
		jmax=j+nbox;
	    }
	    }
	    
	    for (i=jmin;i<jmax;i++) {
		tmp[k]=shift[i];
		k++;
	    }
	    me=fmean(tmp,k);
	    sig=fsigma(tmp,k,me);
//	printf("nsigma=%f\n",nsigma);
//	printf("%d %f %f %f %f\n",j,shift[j],me,sig,nsigma);
	    if (fabs(shift[j]-me)<nsigma*sig) {
		new_shift[j]=shift[j];
		new_index[j]=index[j];
		ks++;
	    } else {
		new_shift[j]=shift[j];
		new_index[j]=index[j];
		
		if (border==0) {
		shift[j]=me;
		}
		ks++;
	    }
//	printf("%d %f %f\n",j,shift[j],new_shift[j]);
	}
    } else {
	for (j=0;j<image.ny;j++) {
	    new_shift[j]=shift[j];
		new_index[j]=index[j];
	}
    }



    if ((plot==1)||(plot==2)) {
    
	cpgopen("/xs");
	cpgsfs(1.2);
	cpgscf(2);            
	cpgslw(2); 
	cpgsch(1.6);
	cpgenv(0,image.ny,shift_min-1,shift_max+1,0,0);
	cpgsch(1.6);        
	cpglab("Y index","Delta","Shifts");
	cpgsch(2.2);          
	cpgsci(1);
	cpgpt(image.ny,index,new_shift,1);
	cpgsci(3);
	cpgpt(image.ny,index,shift,22);
	cpgsci(2);
	cpgline(image.ny,index,shift);
	cpgsci(1);
	cpgclos();
	cpgend;
	stdin;
	printf("Press Enter"); 
	command=getc(stdin);	
	command=getc(stdin);	
    }

//*******************

    printf("Shifting the new cube...\n");
    for (j=0;j<image.ny;j++) {
	fmin=1e12;
	fmax=-1e12;
	if (shift[j]!=0) {
	    for (k=0;k<image.nx;k++) {    
		in_spec[k]=RD_frame(&image,k,j);
		in_wave[k]=1.0*k;
		Wave[k]=1.0*k-shift[j];
		shift_wave[k]=1.0*k-shift[j];
		if ((k>=Jmin)&&(k<=Jmax)) {
		    if (in_spec[k]<fmin) {
			fmin=in_spec[k];
		    }
		    if (in_spec[k]>fmax) {
			fmax=in_spec[k];
		    }
		}
		if (j==n_fib) {
		    spec[k]=in_spec[k];
		    wave[k]=in_wave[k];
		}
	    }
//	    spline1(in_wave,in_spec,image.nx,Wave,Spec,image.nx);
	    spline1(Wave,in_spec,image.nx,in_wave,Spec,image.nx);
	    for (k=0;k<image.nx;k++) {
		out_array[k+j*image.nx]=Spec[k];
	    }
	
	    if ((plot==1)||(plot==2)) {
		cpgopen("/xs");
		cpgsfs(1.2);
		cpgscf(2);      
		cpgslw(2);          
		cpgsch(1.6);       
		if (fmax<0) {
		    fmax=100;
		    fmin=-100;
		}
		cpgenv(Jmin,Jmax,fmin-1,fmax+500,0,0);
		cpgsch(1.6);           
		cpglab("Id.","Counts","");
		cpgsch(2.2);
		cpgsci(1);
		cpgline(image.nx,wave,spec);    
		cpgsci(2);
		cpgline(image.nx,in_wave,in_spec);    
		cpgsci(3);
		cpgline(image.nx,shift_wave,in_spec);    
		cpgsci(5);
		cpgline(image.nx,in_wave,Spec);    
		cpgsci(1);
		cpgclos();
		cpgend;
	    }
	} else {
	    for (k=0;k<image.nx;k++) {    
		out_array[k+j*image.nx]=RD_frame(&image,k,j);
	    }
	}
    
    }
    close_frame(&image); 

    printf("Writting the output solution: %s\n",dist_file);
    create_frame(&dist,dist_file,npix,start,step,FLOAT,"EXTRACTED",NULL);
    for (i=0;i<npix[0];i++) {
	for (j=0;j<npix[1];j++) {
	    WR_frame(&dist,i,j,out_array[i+j*npix[0]]);
	}
    }
    close_frame(&dist);    




    printf("Writting the distortion correction file: %s\n",dist_cor_file);
    FH=fopen(dist_cor_file,"w");
    for (j=0;j<npix[1];j++) {
	fprintf(FH,"%f %f\n",index[j],shift[j]);
    }
    fclose(FH);

    return(0);
}

/*

#!/usr/bin/perl
#
# This programs creates a set of fits files
# extracting the information from the line-fitting results.
#








#print "i_peak[n_fib] w_peak[n_fib]\n";

#print "NM=nm\n";






#exit;



#
#cleaning
#





print "DONE\n";
#
# Check the offsets
#
if (smooth==1) {
    npoly=3;
    shift_pdl = pdl(new_shift);
    index_pdl = pdl(new_index);
    (s_y,coeff) = fitpoly1d index_pdl,shift_pdl,npoly;
    my shift_all;
    for (j=0;j<npoly;j++) {
	c[j]=coeff->slice(j)->sclr;
#    print "c[j] ";
}
    for (j=0;j<naxis[1];j++) {
	shift_all[j]=0;
	index_all[j]=j;
	for (k=0;k<npoly;k++) {
	    shift_all[j]=shift_all[j]+c[k]*(j**k);
	}
#    print "j shift_all[j]\n";
	
    }
} else {
    for (j=0;j<naxis[1];j++) {
	index_all[j]=j;
	shift_all[j]=shift[j];
    }
}




#exit;


print "DONE\n";
print "Writting the dist_file\n";
system("rm dist_file");
system("cp infile dist_file");
update_fits(dist_file,nax,2,\out_cube);
print "DONE\n";

print "DONE\n";


exit;





#open(FH,">output_back");
#m=1;
#for (k=0;k<npow;k++) {
#    print FH "m w[k] back_spec[k]\n";
#    m++;
#}
#close(FH);

*/









